function love.load()
  blocks = {}
  plr = {}
  plr.tx = 0
  plr.ty = 0
  plr.sp = 3
  plr.dr = "none"
  canMove = true
  moving = false
  holding = false
  moved = 0
  fps = 8
  frame = 0
  numFrames = 3
  ani = 1/fps
  signCount = 0
  guys = 0
  girls = 0
  worky = false
  tbTXT = ""
  glbT = ""
  glbC = 1
  canSkip = true
  triggered = false
  inHouse = false
  Ttimes = 0
  Rtimes = 0
  Tinfo = {""}
  -- function --
  function newBlock(t,x,y,r,g,b)
    block = {}
    block.type = t
    block.x = x
    block.y = y
    block.r = r
    block.g = g
    block.b = b
    block.info = {""}
    block.times = 0
    block.sc = 0
    block.gu = 0
    block.gr = 0
    block.int = false
    block.tx = x/50
    block.ty = y/50
    block.wx = 0
    block.wy = 50
    block.w,block.h = 50,50
    table.insert(blocks,block)
  end
  
  function textBox(ti,txt)
    Ttimes = ti
    Rtimes = 1
    Tinfo = txt
    canMove = false
    worky = true
    glbT = txt[Rtimes]
  end
  
  function move(dir)
    ok = true
    plr.dr = dir
    if dir == "up" then
      for _,co in pairs(blocks) do
        if co.tx == plr.tx and co.ty == plr.ty - 1 then
          ok = false
        end
      end
    elseif dir == "left" then
      for _,co in pairs(blocks) do
        if co.tx == plr.tx - 1 and co.ty == plr.ty then
          ok = false
        end
      end
    elseif dir == "down" then
      for _,co in pairs(blocks) do
        if co.tx == plr.tx and co.ty == plr.ty + 1 then
          ok = false
        end
      end
    elseif dir == "right" then
      for _,co in pairs(blocks) do
        if co.tx == plr.tx + 1 and co.ty == plr.ty then
          ok = false
        end
      end
    end
    if ok == true then
      if dir == "up" then
        plr.ty = plr.ty - 1
        moving = true
      elseif dir == "left" then
        plr.tx = plr.tx - 1
        moving = true
      elseif dir == "down" then
        plr.ty = plr.ty + 1
        moving = true
      elseif dir == "right" then
        plr.tx = plr.tx + 1
        moving = true
      end
    end
    ok = true
  end
  
  mapPath = "assets/map/"
  map = love.image.newImageData(mapPath.."wholeMap.png")
  
  walkX = 0
  walkY = 50
  chrPath = "assets/characters/"
  walk = love.graphics.newImage(chrPath.."main_char.png")
  spr_walk = love.graphics.newQuad(walkX,walkY,50,50,walk:getDimensions())
  npcGuy = love.graphics.newImage(chrPath.."npc_guy.png")
  spr_guy = love.graphics.newQuad(0,50,50,50,npcGuy:getDimensions())
  npcGrl = love.graphics.newImage(chrPath.."npc_girl.png")
  spr_grl = love.graphics.newQuad(0,50,50,50,npcGrl:getDimensions())
  
  tilPath = "assets/tiles/"
  brick = love.graphics.newImage(tilPath.."brick.png")
  wood = love.graphics.newImage(tilPath.."wood.png")
  sign = love.graphics.newImage(tilPath.."sign.png")
  fnch = love.graphics.newImage(tilPath.."fenceH.png")
  fncv = love.graphics.newImage(tilPath.."fenceV.png")
  fld = love.graphics.newImage(tilPath.."fLD.png")
  frd = love.graphics.newImage(tilPath.."fRD.png")
  fru = love.graphics.newImage(tilPath.."fRU.png")
  flu = love.graphics.newImage(tilPath.."fLU.png")
  
  function enter()
    for _,en in pairs(blocks) do
      if en.type == "entrance" and en.tx == plr.tx and en.ty == plr.ty - 1 and en.y == 250 then
        for i=1,40 do
          for _,mov in pairs(blocks) do
            mov.x = mov.x - 50
          end
          plr.tx = plr.tx + 1
        end
        for _,mov in pairs(blocks) do
          mov.y = mov.y + 50
        end
        plr.ty = plr.ty - 1
        inHouse = true
      end
    end
  end
  
  function exit()
    for _,en in pairs(blocks) do
      if en.type == "exit" and en.tx == plr.tx and en.ty == plr.ty + 1 and en.y == 350 then
        for i=1,40 do
          for _,mov in pairs(blocks) do
            mov.x = mov.x + 50
          end
          plr.tx = plr.tx - 1
        end
        for _,mov in pairs(blocks) do
          mov.y = mov.y - 50
        end
        plr.ty = plr.ty + 1
        inHouse = false
      end
    end
  end
  
  function setMap()
    for i=1,#blocks do
      table.remove(blocks,1)
    end
    
    px = 0
    py = 0
    for i=1,map:getWidth()*map:getHeight() do
      pr,pg,pb = map:getPixel(px,py)
      newBlock("none",px*50,py*50,pr,pg,pb)
      px = px + 1
      if px >= map:getWidth() then
        px = 0
        py = py + 1
      end
      for x,cl in ipairs(blocks) do
        if cl.r == 0 and cl.g == 0 and cl.b == 0 then
          table.remove(blocks,x)
        elseif cl.r == 0 and cl.g == 1 and cl.b == 0 then
          plr.tx = cl.tx
          plr.ty = cl.ty
          table.remove(blocks,x)
        elseif cl.r == 81/255 and cl.g == 32/255 and cl.b == 0 then
          cl.type = "fnch"
        elseif cl.r == 81/255 and cl.g == 50/255 and cl.b == 0 then
          cl.type = "fncv"
        elseif cl.r == 81/255 and cl.g == 60/255 and cl.b == 0 then
          cl.type = "fru"
        elseif cl.r == 81/255 and cl.g == 65/255 and cl.b == 0 then
          cl.type = "flu"
        elseif cl.r == 81/255 and cl.g == 70/255 and cl.b == 0 then
          cl.type = "frd"
        elseif cl.r == 81/255 and cl.g == 75/255 and cl.b == 0 then
          cl.type = "fld"
        elseif cl.r == 127/255 and cl.g == 0 and cl.b == 0 then
          cl.type = "brick"
        elseif cl.r == 122/255 and cl.g == 75/255 and cl.b == 46/255 then
          cl.type = "wood"
        elseif cl.r == 170/255 and cl.g == 75/255 and cl.b == 46/255 then
          cl.type = "sign"
        elseif cl.r == 128/255 and cl.g == 128/255 and cl.b == 128/255 then
          cl.type = "entrance"
        elseif cl.r == 64/255 and cl.g == 64/255 and cl.b == 64/255 then
          cl.type = "exit"
        elseif cl.r == 87/255 and cl.g == 0 and cl.b == 127/255 then
          cl.type = "npc_guy"
        elseif cl.r == 91/255 and cl.g == 127/255 and cl.b == 0 then
          cl.type = "npc_grl"
        end
      end
    end
  end
  --------------
  love.window.setTitle("Map Maker")
  love.mouse.setVisible(false)
  setMap()
  
  for _,ng in pairs(blocks) do
    if ng.type == "npc_guy" then
      guys = guys + 1
      ng.gu = guys
      ng.int = true
      if ng.gu == 1 then
        ng.info = {"This is my brick collection!","NO TOUCHY"}
        ng.times = #ng.info
        ng.wy = 50
      end
    end
  end
  
  for _,ngf in pairs(blocks) do
    if ngf.type == "npc_grl" then
      girls = girls + 1
      ngf.gr = girls
      ngf.int = true
      if ngf.gr == 1 then
        ngf.info = {"If I let you in my house my bf would kill me.","We can still be friends though!"}
        ngf.times = #ngf.info
        ngf.wy = 50
      elseif ngf.gr == 2 then
        ngf.info = {"GUESS WHAT STINKY","YOU ARE SO DUMB","YOU ARE SUCH AN IDIOT","GO DIE IN A HOLE YOU FRICKIN LOSER"}
        ngf.times = #ngf.info
        ngf.wy = 0
      end
    end
  end
  
  for _,s in pairs(blocks) do
    if s.type == "sign" then
      signCount = signCount + 1
      s.sc = signCount
      s.int = true
      if s.sc == 1 then
        s.info = {"Welcome to this random poopy house.","May I take your order?"}
        s.times = #s.info
      elseif s.sc == 2 then
        s.info = {"Welcome to this random poopy town.","May I take your order?"}
        s.times = #s.info
      elseif s.sc == 3 then
        s.info = {"This house is so poopy that I pooped my pants."}
        s.times = #s.info
      end
    end
  end
  
  for i=1,6 do
    for _,b2 in pairs(blocks) do
      b2.x = b2.x + 50
      b2.y = b2.y + 50
    end
  end
  
  for i=1,plr.tx do
    for _,b1 in pairs(blocks) do
      b1.x = b1.x - 50
    end
  end
  for i=1,plr.ty do
    for _,b in pairs(blocks) do
      b.y = b.y - 50
    end
  end
end

function love.keypressed(key)
  if key == "escape" then
    love.event.quit()
  elseif key == "e" and worky == false then
    textBox(3,{"Boi, you can't do anything by pressing E","You're stupid for pressing E","lololololololololololololololol"})
  elseif key == "space" and moving == false and holding == false then
    if worky == false then
      int = false
      info = ""
      times = 0
      for _,c in pairs(blocks) do
        if c.int == true then
          if c.tx == plr.tx and c.ty == plr.ty - 1 then
            int = true
            info = c.info
            times = c.times
            plr.dr = "up"
            if c.type == "npc_guy" or c.type == "npc_grl" then
              c.wy = 50
            end
          elseif c.tx == plr.tx - 1 and c.ty == plr.ty then
            int = true
            info = c.info
            times = c.times
            plr.dr = "left"
            if c.type == "npc_guy" or c.type == "npc_grl" then
              c.wy = 150
            end
          elseif c.tx == plr.tx and c.ty == plr.ty + 1 then
            int = true
            info = c.info
            times = c.times
            plr.dr = "down"
            if c.type == "npc_guy" or c.type == "npc_grl" then
              c.wy = 0
            end
          elseif c.tx == plr.tx + 1 and c.ty == plr.ty then
            int = true
            info = c.info
            times = c.times
            plr.dr = "right"
            if c.type == "npc_guy" or c.type == "npc_grl" then
              c.wy = 100
            end
          end
        end
      end
      if int == true then
        textBox(times,info)
      end
    else
      if tbTXT == glbT then
        if Rtimes == Ttimes then
          worky = false
          canMove = true
          tbTXT = ""
          Ttimes = 0
          Tinfo = {""}
          Rtimes = 0
          glbT = ""
          glbC = 1
        else
          Rtimes = Rtimes + 1
          tbTXT = ""
          glbC = 1
          glbT = Tinfo[Rtimes]
        end
      else
        if canSkip == true then
          tbTXT = glbT
          glbC = string.len(glbT)
        end
      end
    end
  end
end

function love.update(dt)
  if worky == true and moving == false and tbTXT ~= glbT then
    tbTXT = glbT:sub(1,glbC)
    glbC = glbC + 1
  end
  if plr.dr == "up" then
    spr_walk:setViewport(walkX,0,50,50)
  elseif plr.dr == "left" then
    spr_walk:setViewport(walkX,100,50,50)
  elseif plr.dr == "down" then
    spr_walk:setViewport(walkX,50,50,50)
  elseif plr.dr == "right" then
    spr_walk:setViewport(walkX,150,50,50)
  end
  if inHouse == true then
    love.graphics.setBackgroundColor(173/255,103/255,65/255)
  else
    love.graphics.setBackgroundColor(23/255,101/255,23/255)
  end
  if (love.keyboard.isDown("w") or love.keyboard.isDown("up")) then
    if moving == false and canMove == true then
      enter()
      move("up")
      holding = true
    end
  elseif (love.keyboard.isDown("a") or love.keyboard.isDown("left")) then
    if moving == false and canMove == true then
      move("left")
      holding = true
    end
  elseif (love.keyboard.isDown("s") or love.keyboard.isDown("down")) then
    if moving == false and canMove == true then
      exit()
      move("down")
      holding = true
    end
  elseif (love.keyboard.isDown("d") or love.keyboard.isDown("right")) then
    if moving == false and canMove == true then
      move("right")
      holding = true
    end
  elseif not love.keyboard.isDown("w") and not love.keyboard.isDown("up") and not love.keyboard.isDown("s") and not love.keyboard.isDown("down") and not love.keyboard.isDown("a") and not love.keyboard.isDown("left") and not love.keyboard.isDown("d") and not love.keyboard.isDown("right") then
    holding = false
  end
  if moving == true then
    if plr.dr == "up" then
      for _,mo in pairs(blocks) do
        mo.y = mo.y + plr.sp
      end
    elseif plr.dr == "left" then
      for _,mo in pairs(blocks) do
        mo.x = mo.x + plr.sp
      end
    elseif plr.dr == "down" then
      for _,mo in pairs(blocks) do
        mo.y = mo.y - plr.sp
      end
    elseif plr.dr == "right" then
      for _,mo in pairs(blocks) do
        mo.x = mo.x - plr.sp
      end
    end
    moved = moved + 1
    if moved >= 50/plr.sp then
      if plr.dr == "up" then
        for _,mo in pairs(blocks) do
          mo.y = mo.y - 1
        end
      elseif plr.dr == "left" then
        for _,mo in pairs(blocks) do
          mo.x = mo.x - 1
        end
      elseif plr.dr == "down" then
        for _,mo in pairs(blocks) do
          mo.y = mo.y + 1
        end
      elseif plr.dr == "right" then
        for _,mo in pairs(blocks) do
          mo.x = mo.x + 1
        end
      end
      moved = 0
      moving = false
    end
  end
  if (holding == false and moving == false) and not love.keyboard.isDown("w") and not love.keyboard.isDown("up") and not love.keyboard.isDown("s") and not love.keyboard.isDown("down") and not love.keyboard.isDown("a") and not love.keyboard.isDown("left") and not love.keyboard.isDown("d") and not love.keyboard.isDown("right") then
    frame = 0
    walkX = 0
    ani = 1/fps
  end
  if holding == true or moving == true then ani = ani - dt end
  if ani <= 0 then
    ani = 1/fps
    frame = frame + 1
    if frame > numFrames then
      frame = 0
    end
    walkX = 50 * frame
  end
end

function love.draw()
  borderX = -50
  borderY = 700
  love.graphics.setColor(1,1,1)
  for _,b in pairs(blocks) do
    if (b.x > borderX and b.x < borderY) and (b.y > borderX and b.y < borderY) then
      if b.type == "brick" then
        love.graphics.draw(brick,b.x,b.y)
      elseif b.type == "wood" then
        love.graphics.draw(wood,b.x,b.y)
      elseif b.type == "sign" then
        love.graphics.draw(sign,b.x,b.y)
      elseif b.type == "fnch" then
        love.graphics.draw(fnch,b.x,b.y)
      elseif b.type == "fncv" then
        love.graphics.draw(fncv,b.x,b.y)
      elseif b.type == "fld" then
        love.graphics.draw(fld,b.x,b.y)
      elseif b.type == "frd" then
        love.graphics.draw(frd,b.x,b.y)
      elseif b.type == "flu" then
        love.graphics.draw(flu,b.x,b.y)
      elseif b.type == "fru" then
        love.graphics.draw(fru,b.x,b.y)
      elseif b.type == "entrance" or b.type == "exit" then
        love.graphics.setColor(0,0,0)
        love.graphics.rectangle("fill",b.x,b.y,50,50)
        love.graphics.setColor(1,1,1)
      elseif b.type == "npc_guy" then
        spr_guy:setViewport(b.wx,b.wy,50,50)
        love.graphics.draw(npcGuy,spr_guy,b.x,b.y)
      elseif b.type == "npc_grl" then
        spr_grl:setViewport(b.wx,b.wy,50,50)
        love.graphics.draw(npcGrl,spr_grl,b.x,b.y)
      end
    end
  end
  love.graphics.draw(walk,spr_walk,300,300)
  if worky == true then
    love.graphics.setColor(0,0,0,.5)
    love.graphics.rectangle("fill",50,love.graphics.getHeight()-150,love.graphics.getWidth()-100,100)
    love.graphics.setColor(1,1,1)
    love.graphics.print(tbTXT,65,love.graphics.getHeight()-135)
  end
end